(function() {

// constructor
function DialogBox() {
    this.Container_constructor();
    
    this._boxWidth = 450;
    this._boxHeight = 450;
    this._boxMargin = 25;
    
    this._lineHeight = 22;
    
    this._lastPressPosition = null;
    this._heightMeasuring = 0;
    this._startBracketIndexes = new Array();
    this._endBracketIndexes = new Array();
    this._firstBracketIndex = 0;
    
    var bg = new createjs.Shape();
    bg.graphics.beginFill(createjs.Graphics.getRGB(0,0,0,0.5)).drawRoundRect(0, 0, this._boxWidth, this._boxHeight, 10).endFill();
    bg.cache(0, 0, this._boxWidth, this._boxHeight);
    this.addChild(bg);
    
    this._textContainer = new createjs.Container();
    this.addChild(this._textContainer);
    
    this._textContainer.shadow = new createjs.Shadow(createjs.Graphics.getRGB(0,0,0,0.5), 1, 1, 3);
    
    this._textMask = new createjs.Shape();
    this._textMask.graphics.beginFill("#000").drawRoundRect(0, this._boxMargin-5, this._boxWidth, this._boxHeight - ((this._boxMargin-5) * 2), 10).endFill();
    this._textMask.mouseEnabled = false;
    this._textContainer.mask = this._textMask;
    
    //drag scroll (TODO: make more clever)
    /*this.on("pressmove", function(e) {
        if (this._lastPressPosition != null) {
            if (e.stageY > this._lastPressPosition.y) {
                this._textContainer.y -= 2;
            }
            else if (e.stageY < this._lastPressPosition.y) {
                this._textContainer.y += 2;
            }
        }
        this._lastPressPosition = new createjs.Point(e.stageX, e.stageY);
    });*/
    
    this._texts = new Array();
    this._addTextPart('I quickly read the letter. \n\n_Mr. Behring, \nWe hereby grant you a ship and 34 men. You must take the journey east from St. Petersburg, and map a safe route to North America. Bring back animal hides from Alaska as proof. You will be generously rewarded for every new isle, tribe, flora and fauna you discover. \n\nBest wishes, \nAlexander the Great, Emperor of Russia_\n\nReading the letter left me shocked. \n\n[[I never wished for this...|initialchoice1]] \n\n[[I have always dreamt of this...|initialchoice2]]');
};
var p = createjs.extend(DialogBox, createjs.Container);

// public methods:
p.mouseOverListener = function(e){
    
};

p.mouseOutListener = function(e){
    
};

p._clickListener = function(e, data) {
    //console.log("click on: " + data.xIndex + ", " + data.yIndex);
    //console.log( this.getObjectsUnderPoint(this.getStage().mouseX, this.getStage().mouseY) );
    //console.log(data);
    
    console.log(data.choiceClicked);
    
    this._addTextPart('But standing up against Alexander The Great was not worth considering. "I should prepare immediatly," I told myself.');
};

//Creates a txt.Text, positions it after the others and animates it into view
p._addTextPart = function(string) {
    var that = this;
    var i, j = 0;
    
    //remove previous bracket lines
    if (this._texts.length > 0) {
        this._texts[this._texts.length-1].text = this._texts[this._texts.length-1].text.substring(0, this._firstBracketIndex);
        this._texts[this._texts.length-1].complete = function() {};
        this._texts[this._texts.length-1].layout();
    }
    
    //add after previous text box
    var yOffset = this._lineHeight;
    var heightMeasuring = 0;
    if (this._texts.length > 0) {
        for (i = 0; i < this._texts.length; i++) {
            for (j = 0; j < this._texts[i].lines.length; j++) {
                heightMeasuring += this._texts[i].lines[j].measuredHeight;
            }
        }
        yOffset += heightMeasuring;
        yOffset += this._lineHeight;
    }
    
    //find bracketed words (for links)
    words = string.split(' ');
    this._startBracketIndexes = new Array();
    for (i = 0; i < words.length; i++) {
        if (words[i].indexOf("[[") > -1) {
            this._startBracketIndexes.push(i);
        }
    }
    this._endBracketIndexes = new Array();
    for (i = 0; i < words.length; i++) {
        if (words[i].indexOf("]]") > -1) {
            this._endBracketIndexes.push(i);
        }
    }
    var choices = new Array();
    for (i = 0; i < words.length; i++) {
        if (words[i].indexOf("|") > -1) {
            var choice = words[i].slice(words[i].indexOf("|")+1, words[i].indexOf("]]"));
            choices.push(choice);
        }
    }
    //console.log(this._startBracketIndexes);
    //console.log(this._endBracketIndexes);
    //console.log(choices);
    
    //remove choice formating
    var c = 0;
    while (string.indexOf("|") != -1) {
        var index = string.indexOf("|");
        string = string.slice(0, index) + string.slice(index+choices[c].length+1);
        c++;
    }
    
    //remove bracket formating
    this._firstBracketIndex = string.indexOf("[[");
    string = string.replace(/[\[\]']+/g,'');
    //var wordCount = string.match(/\S+/g).length;
    
    //build style array
    var styleArray = new Array();
    var textFont = 'robotocondensed';
    var quoteFont = 'robotocondensed_bold';
    var linkFont = 'robotocondensed_italic';
    var currentFont = textFont;
    var currentSize = 18;
    for (i = 0; i < string.length; i++) {
        if (string[i] == '_') {
            if (currentFont == textFont) {
                currentFont = quoteFont;
                currentSize = 16;
            }
            else {
                currentFont = textFont;
                currentSize = 18;
            }
        }
        if (i == this._firstBracketIndex) {
            currentFont = linkFont;
        }
        
        var s = {size:currentSize, font:currentFont};
        styleArray.push(s);
    }
    
    //remove underscores (marking bold text)
    while (string.indexOf("_") != -1) {
        var index = string.indexOf("_");
        string = string.slice(0, index) + string.slice(index+1);
        styleArray.splice(index, 1);
        this._firstBracketIndex--;
    }
    
    var text = new txt.Text( { 
        text:string,
        font:'robotocondensed',
        fillColor:'#FFF',
        //strokeColor:'#AAA',
        //strokeWidth:0,
        characterCase:txt.Case.NORMAL,
        lineHeight:that._lineHeight,
        align:txt.Align.TOP_LEFT,
        style:styleArray,
        width:that._boxWidth - (that._boxMargin * 2),
        height:0,
        size:18,
        alpha:0.0,
        x:that._boxMargin,
        y:yOffset,
        debug:false,
        complete:function() {
            this.alpha = 1.0;
            
            //word animation
            for (i = 0; i < this.words.length; i++) {
                this.words[i].alpha = 0.0;
                createjs.Tween.get(this.words[i], {loop:false, override:true}).wait(i * 20).to({alpha:1.0}, 1000, createjs.Ease.cubicOut);
            }
            
            //line animation
            var alt = 1;
            for (i = 0; i < this.lines.length; i++) {
                this.lines[i].x = this.lines[i].x + (50 * alt);
                this.lines[i].y = this.lines[i].y + 50;
                //createjs.Tween.get(this.lines[i], {loop:false, override:true}).wait(i * 100).to({x:this.lines[i].x - (50 * alt)}, 1500, createjs.Ease.cubicOut);
                //createjs.Tween.get(this.lines[i], {loop:false, override:true}).wait(i * 50).to({y:this.lines[i].y - 50}, 1500, createjs.Ease.cubicOut);
                createjs.Tween.get(this.lines[i], {loop:false, override:true}).wait(i * 50).to({y:this.lines[i].y - 50, x:this.lines[i].x - (50 * alt)}, 1500, createjs.Ease.cubicOut);
                alt *= -1;
            }
            
            //auto scroll animation (TODO: make more clever and fit with manual scroll)
            that._heightMeasuring = 0;
            for (i = 0; i < that._texts.length; i++) {
                for (var j = 0; j < that._texts[i].lines.length; j++) {
                    that._heightMeasuring += that._texts[i].lines[j].measuredHeight;
                }
            }
            if (that._heightMeasuring > that._boxHeight - (that._boxMargin * 2) - that._textContainer.y) {
                createjs.Tween.get(that._textContainer, {loop:false, override:true}).to({y:that._textContainer.y-(this.lineHeight*10)}, 1000, createjs.Ease.cubicInOut);
            }
            
            //remove empty words (newlines) (TODO: maybe just skip them somehow?)
            for (i = 0; i < this.words.length; i++) {
                if (this.words[i].hasNewLine) {
                    this.words.splice(i, 1);
                    i--;
                }
            }
            
            //add click areas
            for (i = 0; i < that._startBracketIndexes.length; i++) {
                var startWordIndex = that._startBracketIndexes[i];
                var endWordIndex = that._endBracketIndexes[i];
                var rectWidth = this.words[endWordIndex].x - this.words[startWordIndex].x;
                var rect = that._getRect(rectWidth + this.words[endWordIndex].measuredWidth, this.words[startWordIndex].measuredHeight, "#000");
                rect.y -= this.size - 3;
                rect.cursor = "pointer";
                this.words[startWordIndex].addChild(rect);
                
                //click listener
                this.words[startWordIndex].on("click", that._clickListener, that, false, {choiceClicked:choices[i]});
            }
        }
    } );
    this._texts.push(text);
    this._textContainer.addChild(text);
};

p._getRect = function(w, h, color) {
    var container = new createjs.Container();
    var rect = new createjs.Shape();
    var line = new createjs.Shape();
    rect.graphics.beginFill(createjs.Graphics.getRGB(0,0,0,0.01)).drawRect(0, 0, w, h).endFill();
    line.graphics.beginFill(createjs.Graphics.getRGB(255,255,255,1.0)).drawRect(0, h-1, w, 1).endFill();
    rect.regX = line.regX = 0;
    rect.regY = line.regY = 0;
    rect.cache(0, 0, w, h);
    line.cache(0, h-1, w, h-1);
    container.addChild(rect);
    container.addChild(line);
    
    return container;
};

window.DialogBox = createjs.promote(DialogBox, "Container");
}());