(function() {

//
function EnemyTank(parentScene) {
    this.Container_constructor();
  
    this._parentScene = parentScene;
    
    this.active = true;
    this.maxSpeed = 1.0;
    this.energy = 3;
    
    this._launching = false;
    this._tankSpeed = 2.0;
    
	this._vX = 0;
	this._vY = 0;
    
    this.flashDelay = 5;
    this._flashTicker = 0;
    
    //add childs
    this._bitmap = new createjs.Bitmap( this._parentScene.getLoadResult("hitler_tank") );
    this._bitmap.cache(0, 0, this._bitmap.getBounds().width, this._bitmap.getBounds().height);
    this._bitmap.regX = this._bitmap.getBounds().width/2;
    this._bitmap.regY = this._bitmap.getBounds().height;
    this.addChild(this._bitmap);
    
    //add childs
    this._bitmapHit = new createjs.Bitmap( this._parentScene.getLoadResult("hitler_tank_hit") );
    this._bitmapHit.cache(0, 0, this._bitmapHit.getBounds().width, this._bitmapHit.getBounds().height);
    this._bitmapHit.regX = this._bitmapHit.getBounds().width/2;
    this._bitmapHit.regY = this._bitmapHit.getBounds().height;
    this._bitmapHit.visible = false;
    this.addChild(this._bitmapHit);
    
    //add childs
    this._bitmapExhaust = new createjs.Bitmap( this._parentScene.getLoadResult("hitler_tank_exhaust") );
    this._bitmapExhaust.cache(0, 0, this._bitmapExhaust.getBounds().width, this._bitmapExhaust.getBounds().height);
    this._bitmapExhaust.regX = this._bitmapExhaust.getBounds().width/2;
    this._bitmapExhaust.regY = 0;
    this._bitmapExhaust.visible = false;
    this.addChild(this._bitmapExhaust);
};
var p = createjs.extend(EnemyTank, createjs.Container);

// public methods:	
p.tick = function(){
    //move by velocity
    this.x += this._vX * this._tankSpeed;
    this.y += this._vY * this._tankSpeed;
    
    if (this.active) {
        if (this.y > GameEngine.H + this._bitmap.getBounds().height || this.y < -20) {
            this.active = false;
        }
        else if (this.x > GameEngine.W + this._bitmap.getBounds().width|| this.x < -this._bitmap.getBounds().width) {
            this.active = false;
        }
        
        if (this._launching) {
            this._tankSpeed = Math.min(this._tankSpeed + this._tankSpeed + 0.0000001, this.maxSpeed);
            this._bitmapExhaust.scaleY = 1 + (Math.random() / 3);
        }
    }
    
    //countdown flash delay
    this._flashTicker = Math.max(this._flashTicker - 1, 0);
    
    if (this._flashTicker == 0) {
        this._bitmapHit.visible = false;
    }
};

p.startLaunch = function(){
    this._launching = true;
    this._tankSpeed = 0.0;
    this._vX = 0;
	this._vY = -1.5;
    this._bitmapExhaust.visible = true;
    this._bitmapExhaust.alpha = 0.0;
    createjs.Tween.get(this._bitmapExhaust, {loop:false, override:true}).to({alpha:1.0}, 500, createjs.Ease.cubicInOut);
};

p.isDriving = function(){
    return !this._launching;
};

p.collides = function(xPos, yPos, dist) {
    if (Utility.distance(xPos-this.x, yPos-this.y+60) < dist) {
        return true;
    }
    else {
        return false;
    }
};

p.setVelocity = function(vX, vY){
    this._vX = vX;
	this._vY = vY;
};

p.isMovingRight = function(){
    return this._vX > 0;
};

p.flash = function() {
    this._bitmapHit.visible = true;
    this._flashTicker = this.flashDelay;
};

window.EnemyTank = createjs.promote(EnemyTank, "Container");
}());