(function(window) {

//
function Shot(darkShot, lightShot) {
  this.initialize(darkShot, lightShot);
}
var p = Shot.prototype = new createjs.Container();

// static properties:
    Shot.DARK = false;
    Shot.LIGHT = true;

// public properties:
    p.shotColor = Shot.DARK;
    p.speed = 10.0;
    p.active = false;
    
// private properties
    p._darkShot = null;
    p._lightShot = null;
    
// constructor:
	p.Container_initialize = p.initialize;	//unique to avoid overiding base class
	
	p.initialize = function(darkShot, lightShot) {
        //init parent
		this.Container_initialize();
        
        //add childs
        this._darkShot = new createjs.Bitmap(darkShot);
        this._darkShot.cache(0, 0, darkShot.width, darkShot.height);
        this._darkShot.regX = darkShot.width/2;
        this._darkShot.regY = darkShot.height/2;
        this.addChild(this._darkShot);
        
        this._lightShot = new createjs.Bitmap(lightShot);
        this._lightShot.cache(0, 0, lightShot.width, lightShot.height);
        this._lightShot.regX = lightShot.width/2;
        this._lightShot.regY = lightShot.height/2;
        this._lightShot.visible = false;
        this.addChild(this._lightShot);
	};
	
// public methods:	
    p.tick = function(){
        //move by speed
		this.y -= this.speed;
        
        if (this.active) {
            if (this.y < -10) {
                this.active = false;
            }
        }
    };
    
    p.setColor = function(color) {
		this.shotColor = color;
        this._darkShot.visible = !this.shotColor;
        this._lightShot.visible = this.shotColor;
    };
    
    
window.Shot = Shot;
}(window));